﻿@page "/region-list"
@inject HttpClient httpClient
@inject IDialogService _dialogService;
@inject ISnackbar Snackbar

<PageTitle Title="地方" Description="地方マスタのメンテナンスをします。"></PageTitle>

<MudTable Items="@Elements" FixedHeader="true" LoadingProgressColor="Color.Primary"
          Loading="@loading" Hover="true" Bordered="true"
          Filter="new Func<RegionEntity,bool>(FilterFunc1)" @bind-SelectedItem="selectedItem1">
    <ToolBarContent>
        <MudTextField @bind-Value="searchString1" Placeholder="地域名を入力しエンターを押下してください。" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
        <MudSpacer />
        <MudTooltip Text="新規追加">
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Medium" IconSize="Size.Small" Class="ma-2" @onclick="(e => Create())" />
        </MudTooltip>
    </ToolBarContent>
    <HeaderContent>
        <MudTh>地域ID</MudTh>
        <MudTh>地域名</MudTh>
        <MudTh>操作</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd DataLabel="RegionId">@context.RegionId</MudTd>
        <MudTd DataLabel="RegionName">@context.RegionName</MudTd>
        <MudTd>
            <MudTooltip Text="照会">
                <MudFab Color="Color.Primary" OnClick="@(e => Show(@context.RegionId))" Icon="@Icons.Material.Filled.ListAlt" Size="Size.Small"></MudFab>
            </MudTooltip>
            <MudTooltip Text="編集">
                <MudFab Color="Color.Primary" OnClick="@(e => Update(@context.RegionId))" Icon="@Icons.Material.Filled.Edit" Size="Size.Small"></MudFab>
            </MudTooltip>
            <MudTooltip Text="削除">
                <MudFab Color="Color.Primary" OnClick="@(e => Delete(@context.RegionId))" Icon="@Icons.Material.Filled.Delete" Size="Size.Small"></MudFab>
            </MudTooltip>
        </MudTd>
    </RowTemplate>
    <PagerContent>
        <MudTablePager RowsPerPageString="1ページ当たりの行数" />
    </PagerContent>
</MudTable>

<div class="d-flex flex-wrap mt-4">
    <MudSwitch @bind-Checked="@loading" Color="Color.Primary">Loading</MudSwitch>
    <MudSpacer />
    <div style="min-width:200px;">
        <MudText Inline="true" Class="align-self-center">Selected1: @selectedItem1?.RegionName</MudText>
    </div>
</div>

@code {
    private bool loading = true;
    private string searchString1 = "";
    private RegionEntity selectedItem1 = null;
    private HashSet<RegionEntity> selectedItems = new HashSet<RegionEntity>();

    private IEnumerable<RegionEntity> Elements = new List<RegionEntity>();

    protected override async Task OnInitializedAsync()
    {
        loading = true;
        Elements = await httpClient.GetFromJsonAsync<List<RegionEntity>>("api/Regions");
        loading = false;
    }

    private bool FilterFunc1(RegionEntity element) => FilterFunc(element, searchString1);

    private bool FilterFunc(RegionEntity element, string searchString)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        if (element.RegionName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        return false;
    }

    private async Task Create()
    {
        var parameters = new DialogParameters();
        parameters.Add("Region", new RegionEntity());

        var dialog = await _dialogService.Show<RegionDetail>("地域新規作成", parameters).Result;
        if (dialog.Data != null)
        {
            RegionEntity newRegion = dialog.Data as RegionEntity;
            await httpClient.PostAsJsonAsync<RegionEntity>("api/Regions", newRegion);
            await OnInitializedAsync();
            Snackbar.Add($"{newRegion.RegionName}を追加しました。", Severity.Success);
        }

    }

    private async Task Show(int regionId)
    {
        RegionEntity region = await httpClient.GetFromJsonAsync<RegionEntity>($"api/Regions/{regionId}");

        var parameters = new DialogParameters();
        parameters.Add("Region", region);
        parameters.Add("IsReadOnly", true);
        var dialog = await _dialogService.Show<RegionDetail>("地域編集", parameters).Result;
    }

    private async Task Update(int regionId)
    {
        RegionEntity region = await httpClient.GetFromJsonAsync<RegionEntity>($"api/Regions/{regionId}");

        var parameters = new DialogParameters();
        parameters.Add("Region", region);
        var dialog = await _dialogService.Show<RegionDetail>("地域編集", parameters).Result;

        if (dialog.Data != null)
        {
            RegionEntity updateRegion = dialog.Data as RegionEntity;
            updateRegion.UpdatedOn = DateTime.Now;
            await httpClient.PutAsJsonAsync<RegionEntity>($"api/Regions/{regionId}", updateRegion);
            await OnInitializedAsync();
            Snackbar.Add($"{updateRegion.RegionName}を保存しました。", Severity.Success);
        }
    }

    private async Task Delete(int regionId)
    {
        RegionEntity deletedRegion = await httpClient.GetFromJsonAsync<RegionEntity>($"api/Regions/{regionId}");
        bool? result = await _dialogService.ShowMessageBox("警告",
                                                       $"{deletedRegion.RegionName}を削除してもよろしいですか？",
                                                       yesText: "削除",
                                                       cancelText: "キャンセル");
        if (result != null && result == true)
        {
            await httpClient.DeleteAsync($"api/Regions/{regionId}");
            await OnInitializedAsync();
            Snackbar.Add($"{deletedRegion.RegionName}を削除しました。", Severity.Success);
        }
    }

}